import { world, ChatSendBeforeEvent } from '@minecraft/server';

const COMMAND_PREFIX = "replace_me";  // <-- Messages starting with this prefix will be ignored by this addon and can be used by other addons

const messageCounts = new Map();
const SPAM_THRESHOLD = 5;
const COOLDOWN_PERIOD = 10000;

function chatrank(data) {
    const sender = data.sender;
    const tags = sender.getTags();
    
    if (tags.includes('mute')) {
        sender.sendMessage("§cYou are muted and cannot send messages.");
        data.cancel = true;
        return;
    }

    if (!messageCounts.has(sender)) {
        messageCounts.set(sender, { count: 1, lastMessageTime: Date.now() });
    } else {
        const messageInfo = messageCounts.get(sender);
        const currentTime = Date.now();
        if (currentTime - messageInfo.lastMessageTime > COOLDOWN_PERIOD) {
            messageInfo.count = 1;
            messageInfo.lastMessageTime = currentTime;
        } else {
            messageInfo.count++;
            messageInfo.lastMessageTime = currentTime;
            const isStaff = tags.includes('staff');
            if (!isStaff && messageInfo.count > SPAM_THRESHOLD) {
                sender.sendMessage("§cPlease do not spam!");
                data.cancel = true;
                return;
            }
        }
        messageCounts.set(sender, messageInfo);
    }
    
    let ranks = tags.filter(tag => tag.startsWith('rank:')).map(tag => tag.replace('rank:', ''));
    ranks = ranks.length ? ranks : ["§aPlayer"];
    let nameColor = '§7';
    const colorTag = tags.find(tag => tag.startsWith('color:'));
    if (colorTag) {
        nameColor = colorTag.replace('color:', '');
    }
    let textColor = '§f';
    const chatColorTag = tags.find(tag => tag.startsWith('chatcolor:'));
    if (chatColorTag) {
        textColor = chatColorTag.replace('chatcolor:', '');
    }
    if (data.message.startsWith(COMMAND_PREFIX)) {
        return;
    }
    const text = `§7[${ranks.join("§r§7] [")}§r§7] ${nameColor}${sender.nameTag}§r§7 >> ${textColor}${data.message}`;
    world.sendMessage({ rawtext: [{ text: text }] });
    data.cancel = true;
}

export { chatrank };
